config/routes.rb
# frozen_string_literal: true

Bulkrax::Engine.routes.draw do
  resources :exporters do
    get :download
    resources :entries, only: %i[show]
  end
  resources :importers do
    put :continue
    get :export_errors
    collection do
      post :external_sets
    end
    resources :entries, only: %i[show]
    get :upload_corrected_entries
    post :upload_corrected_entries_file
  end
end

app/models/bulkrax/application_record.rb
# frozen_string_literal: true

module Bulkrax
  class ApplicationRecord < ActiveRecord::Base
    self.abstract_class = true
  end
end

app/models/bulkrax/csv_collection_entry.rb
# frozen_string_literal: true

module Bulkrax
  class CsvCollectionEntry < CsvEntry
    def factory_class
      Collection
    end

    def build_metadata
      self.parsed_metadata = self.raw_metadata
      add_local
      return self.parsed_metadata
    end

    def collections_created?
      true
    end
  end
end

app/models/bulkrax/csv_entry.rb
# frozen_string_literal: true

require 'csv'

module Bulkrax
  class CsvEntry < Entry
    serialize :raw_metadata, JSON

    def self.fields_from_data(data)
      data.headers.flatten.compact.uniq
    end

    # there's a risk that this reads the whole file into memory and could cause a memory leak
    def self.read_data(path)
      CSV.read(path,
               headers: true,
               header_converters: :symbol,
               encoding: 'utf-8')
    end

    def self.data_for_entry(data)
      # If a multi-line CSV data is passed, grab the first row
      data = data.first if data.is_a?(CSV::Table)
      raw_data = data.to_h
      # If the collection field mapping is not 'collection', add 'collection' - the parser needs it
      raw_data[:collection] = raw_data[collection_field.to_sym] if raw_data.keys.include?(collection_field.to_sym) && collection_field != 'collection'
      # If the children field mapping is not 'children', add 'children' - the parser needs it
      raw_data[:children] = raw_data[collection_field.to_sym] if raw_data.keys.include?(children_field.to_sym) && children_field != 'children'
      return raw_data
    end

    def self.source_identifier_field
      Bulkrax.source_identifier_field_mapping[self.to_s] || 'source_identifier'
    end

    def self.collection_field
      Bulkrax.collection_field_mapping[self.class.to_s] || 'collection'
    end

    def self.children_field
      Bulkrax.parent_child_field_mapping[self.to_s] || 'children'
    end

    def build_metadata
      raise StandardError, 'Record not found' if record.nil?

      unless importerexporter.parser.required_elements?(record.keys)
        raise StandardError, "Missing required elements, required elements are: #{importerexporter.parser.required_elements.join(', ')}"
      end

      self.parsed_metadata = {}
      self.parsed_metadata[Bulkrax.system_identifier_field] = [record['source_identifier']]

      record.each do |key, value|
        next if key == 'collection'
        add_metadata(key, value)
      end

      add_file
      add_visibility
      add_rights_statement
      add_collections
      add_local

      self.parsed_metadata
    end

    def add_file
      self.parsed_metadata['file'] ||= []
      if record['file']&.is_a?(String)
        self.parsed_metadata['file'] = record['file'].split(/\s*[;|]\s*/)
      elsif record['file'].is_a?(Array)
        self.parsed_metadata['file'] = record['file']
      end
      self.parsed_metadata['file'] = self.parsed_metadata['file'].map { |f| path_to_file(f.tr(' ', '_')) }
    end

    def build_export_metadata
      make_round_trippable
      self.parsed_metadata = {}
      self.parsed_metadata['id'] = hyrax_record.id
      self.parsed_metadata[self.class.source_identifier_field] = hyrax_record.id
      self.parsed_metadata['model'] = hyrax_record.has_model.first
      mapping.each do |key, value|
        next if Bulkrax.reserved_properties.include?(key) && !field_supported?(key)
        next unless hyrax_record.respond_to?(key)
        data = hyrax_record.send(key)
        if data.is_a?(ActiveTriples::Relation)
          self.parsed_metadata[key] = data.map { |d| prepare_export_data(d) }.join('; ').to_s unless value[:excluded]
        else
          self.parsed_metadata[key] = prepare_export_data(data)
        end
      end
      unless hyrax_record.is_a?(Collection)
        self.parsed_metadata['file'] = hyrax_record.file_sets.map { |fs| filename(fs).to_s unless filename(fs).blank? }.compact.join('; ')
      end
      self.parsed_metadata
    end

    def prepare_export_data(datum)
      if datum.is_a?(ActiveTriples::Resource)
        datum.to_uri.to_s
      else
        datum
      end
    end

    # In order for the existing exported hyrax_record, to be updated by a re-import
    # we need a unique value in Bulkrax.system_identifier_field
    # add the existing hyrax_record id to Bulkrax.system_identifier_field
    def make_round_trippable
      values = hyrax_record.send(Bulkrax.system_identifier_field.to_s).to_a
      values << hyrax_record.id
      hyrax_record.send("#{Bulkrax.system_identifier_field}=", values)
      hyrax_record.save
    end

    def record
      @record ||= raw_metadata
    end

    def self.matcher_class
      Bulkrax::CsvMatcher
    end

    def collections_created?
      return true if record[self.class.collection_field].blank?
      record[self.class.collection_field].split(/\s*[:;|]\s*/).length == self.collection_ids.length
    end

    def find_or_create_collection_ids
      return self.collection_ids if collections_created?
      valid_system_id(Collection)
      unless record[self.class.collection_field].blank?
        record[self.class.collection_field].split(/\s*[:;|]\s*/).each do |collection|
          c = find_collection(collection)
          self.collection_ids << c.id unless c.blank? || self.collection_ids.include?(c.id)
        end
      end
      return self.collection_ids
    end

    def required_elements?(keys)
      !required_elements.map { |el| keys.include?(el) }.include?(false)
    end

    def required_elements
      %w[title source_identifier]
    end

    # If only filename is given, construct the path (/files/my_file)
    def path_to_file(file)
      # return if we already have the full file path
      return file if File.exist?(file)
      path = importerexporter.parser.path_to_files
      f = File.join(path, file)
      return f if File.exist?(f)
      raise "File #{f} does not exist"
    end
  end
end

app/models/bulkrax/entry.rb
# frozen_string_literal: true

module Bulkrax
  # Custom error class for collections_created?
  class CollectionsCreatedError < RuntimeError; end
  class OAIError < RuntimeError; end
  class Entry < ApplicationRecord
    include Bulkrax::HasMatchers
    include Bulkrax::ImportBehavior
    include Bulkrax::ExportBehavior
    include Bulkrax::Status
    include Bulkrax::HasLocalProcessing

    belongs_to :importerexporter, polymorphic: true
    serialize :parsed_metadata, JSON
    # Do not serialize raw_metadata as so we can support xml or other formats
    serialize :collection_ids, Array
    serialize :last_error, JSON

    paginates_per 5

    attr_accessor :all_attrs

    delegate :parser, :mapping, :replace_files, to: :importerexporter

    delegate :client,
             :collection_name,
             :user,
             to: :parser

    # Retrieve fields from the file
    # @param data - the source data
    # @return Array
    def self.fields_from_data(_data)
      raise StandardError, 'Not Implemented'
    end

    # Read the data from the supplied path
    # @param path - path to the data file
    # @return the data from the file
    def self.read_data(_path)
      raise StandardError, 'Not Implemented'
    end

    # Returns formatted data from the given file for a single Entry
    # @param data - the data from the metadata file
    # @param path - the path to the metadata file (used by some entries to get the file_paths for import)
    # @return Hash containing the data (the entry build_metadata method will know what to expect in the hash)
    def self.data_for_entry(_data)
      raise StandardError, 'Not Implemented'
    end

    def self.source_identifier_field
      raise "Source identifier must be configured for #{self}" if Bulkrax.source_identifier_field_mapping[self.to_s].blank?
      Bulkrax.source_identifier_field_mapping[self.to_s]
    end

    def self.collection_field
      Bulkrax.collection_field_mapping[self.to_s]
    end

    def self.children_field
      Bulkrax.parent_child_field_mapping[self.to_s]
    end

    def build
      return if type.nil?
      return build_for_importer if importer?
      return build_for_exporter if exporter?
    end

    def importer?
      self.importerexporter_type == 'Bulkrax::Importer'
    end

    def exporter?
      self.importerexporter_type == 'Bulkrax::Exporter'
    end

    def valid_system_id(model_class)
      return true if model_class.properties.keys.include?(Bulkrax.system_identifier_field)
      raise(
        "#{model_class} does not implement the system_identifier_field: #{Bulkrax.system_identifier_field}"
      )
    end

    def find_collection(collection_identifier)
      Collection.where(
        Bulkrax.system_identifier_field => collection_identifier
      ).detect { |m| m.send(Bulkrax.system_identifier_field).include?(collection_identifier) }
    end
  end
end

app/models/bulkrax/exporter.rb
# frozen_string_literal: true
module Bulkrax
  class Exporter < ApplicationRecord
    include Bulkrax::ImporterExporterBehavior
    include Bulkrax::Status

    serialize :field_mapping, JSON
    serialize :last_error, JSON

    belongs_to :user
    has_many :exporter_runs, dependent: :destroy, foreign_key: 'exporter_id'
    has_many :entries, as: :importerexporter, dependent: :destroy

    validates :name, presence: true
    validates :parser_klass, presence: true

    delegate :write, :create_from_collection, :create_from_importer, :create_from_worktype, to: :parser

    def export
      current_exporter_run && setup_export_path
      case self.export_from
      when 'collection'
        create_from_collection
      when 'importer'
        create_from_importer
      when 'worktype'
        create_from_worktype
      end
      status_info
    rescue StandardError => e
      status_info(e)
    end

    # #export_source accessors
    # Used in form to prevent it from getting confused as to which value to populate #export_source with.
    # Also, used to display the correct selected value when rendering edit form.
    def export_source_importer
      self.export_source if self.export_from == 'importer'
    end

    def export_source_collection
      self.export_source if self.export_from == 'collection'
    end

    def export_source_worktype
      self.export_source if self.export_from == 'worktype'
    end

    # If field_mapping is empty, setup a default based on the export_properties
    def mapping
      @mapping ||= self.field_mapping ||
                   ActiveSupport::HashWithIndifferentAccess.new(
                     export_properties.map do |m|
                       Bulkrax.default_field_mapping.call(m)
                     end.inject(:merge)
                   ) ||
                   [{}]
    end

    def export_from_list
      [
        [I18n.t('bulkrax.exporter.labels.importer'), 'importer'],
        [I18n.t('bulkrax.exporter.labels.collection'), 'collection'],
        [I18n.t('bulkrax.exporter.labels.worktype'), 'worktype']
      ]
    end

    def export_type_list
      [
        [I18n.t('bulkrax.exporter.labels.metadata'), 'metadata'],
        [I18n.t('bulkrax.exporter.labels.full'), 'full']
      ]
    end

    def importers_list
      Importer.all.map { |i| [i.name, i.id] }
    end

    def current_exporter_run
      @current_exporter_run ||= self.exporter_runs.create!(total_work_entries: self.limit || parser.total)
    end

    def setup_export_path
      FileUtils.mkdir_p(exporter_export_path) unless File.exist?(exporter_export_path)
    end

    def exporter_export_path
      @exporter_export_path ||= File.join(Bulkrax.export_path, self.id.to_s, self.exporter_runs.last.id.to_s)
    end

    def exporter_export_zip_path
      @exporter_export_zip_path ||= File.join(ENV.fetch('RAILS_TMP', Dir.tmpdir).to_s, "export_#{self.id}_#{self.exporter_runs.last.id}.zip")
    rescue
      @exporter_export_zip_path ||= File.join(ENV.fetch('RAILS_TMP', Dir.tmpdir).to_s, "export_#{self.id}_0.zip")
    end

    def export_properties
      properties = Hyrax.config.registered_curation_concern_types.map { |work| work.constantize.properties.keys }.flatten.uniq.sort
      properties.reject { |prop| Bulkrax.reserved_properties.include?(prop) }
    end
  end
end

app/models/bulkrax/exporter_run.rb
# frozen_string_literal: true

module Bulkrax
  class ExporterRun < ApplicationRecord
    belongs_to :exporter

    def exporter_status
      export_runs = exporter.exporter_runs.last

      return "Failed" if export_runs&.processed_records&.zero?
      return "Complete" if export_runs&.enqueued_records&.zero? && export_runs&.processed_records == export_runs&.total_work_entries
      return "Complete (with failures)" if export_runs&.failed_records&.positive?
      return "Not yet exported" unless File.exist?(exporter.exporter_export_zip_path) || export_runs&.total_work_entries&.zero?
    end
  end
end

app/models/bulkrax/importer.rb
# frozen_string_literal: true

require 'iso8601'

module Bulkrax
  class Importer < ApplicationRecord
    include Bulkrax::ImporterExporterBehavior
    include Bulkrax::Status

    serialize :parser_fields, JSON
    serialize :field_mapping, JSON
    serialize :last_error, JSON

    belongs_to :user
    has_many :importer_runs, dependent: :destroy, foreign_key: 'importer_id'
    has_many :entries, as: :importerexporter, dependent: :destroy

    validates :name, presence: true
    validates :admin_set_id, presence: true
    validates :parser_klass, presence: true

    delegate :valid_import?, :create_parent_child_relationships,
             :write_errored_entries_file, :visibility, to: :parser

    attr_accessor :only_updates, :file_style, :file
    # TODO: (OAI only) validates :metadata_prefix, presence: true
    # TODO (OAI only) validates :base_url, presence: true

    # If field_mapping is empty, setup a default based on the export_properties
    def mapping
      @mapping ||= if self.field_mapping.blank? || self.field_mapping == [{}]
                     if parser.import_fields.present? || self.field_mapping == [{}]
                       ActiveSupport::HashWithIndifferentAccess.new(
                         parser.import_fields.reject(&:nil?).map do |m|
                           Bulkrax.default_field_mapping.call(m)
                         end.inject(:merge)
                       )
                     end
                   else
                     self.field_mapping
                   end
    end

    def parser_fields
      self[:parser_fields] || {}
    end

    def self.frequency_enums
      # these duration values use ISO 8601 Durations (https://en.wikipedia.org/wiki/ISO_8601#Durations)
      # TLDR; all durations are prefixed with 'P' and the parts are a number with the type of duration.
      # i.e. P1Y2M3W4DT5H6M7S == 1 Year, 2 Months, 3 Weeks, 4 Days, 5 Hours, 6 Minutes, 7 Seconds
      [['Daily', 'P1D'], ['Monthly', 'P1M'], ['Yearly', 'P1Y'], ['Once (on save)', 'PT0S']]
    end

    def frequency=(frequency)
      self[:frequency] = ISO8601::Duration.new(frequency).to_s
    end

    def frequency
      f = self[:frequency] || "PT0S"
      ISO8601::Duration.new(f)
    end

    def schedulable?
      frequency.to_seconds != 0
    end

    def current_importer_run
      @current_importer_run ||= self.importer_runs.create!(total_work_entries: self.limit || parser.total, total_collection_entries: parser.collections_total)
    end

    def seen
      @seen ||= {}
    end

    def replace_files
      self.parser_fields['replace_files']
    end

    def import_works(only_updates = false)
      self.only_updates = only_updates
      parser.create_works
      status_info
    rescue StandardError => e
      status_info(e)
    end

    def import_collections
      parser.create_collections
      status_info
    rescue StandardError => e
      status_info(e)
    end

    # Prepend the base_url to ensure unique set identifiers
    # @todo - move to parser, as this is OAI specific
    def unique_collection_identifier(id)
      "#{self.parser_fields['base_url'].split('/')[2]}_#{id}"
    end

    # The format for metadata for the incoming import; corresponds to an Entry class
    def import_metadata_format
      [['CSV', 'Bulkrax::CsvEntry'], ['RDF (N-Triples)', 'Bulkrax::RdfEntry']]
    end

    # The type of metadata for the incoming import, either one file for all works, or one file per work
    # def import_metadata_type
    #   [['Single Metadata File for all works', 'single'], ['Multiple Files, one per Work', 'multi']]
    # end

    # If the import data is zipped, unzip it to this path
    def importer_unzip_path
      @importer_unzip_path ||= File.join(ENV.fetch('RAILS_TMP', Dir.tmpdir).to_s, "import_#{self.id}_#{self.importer_runs.last.id}")
    rescue
      @importer_unzip_path ||= File.join(ENV.fetch('RAILS_TMP', Dir.tmpdir).to_s, "import_#{self.id}_0")
    end

    def errored_entries_csv_path
      @errored_entries_csv_path ||= File.join(ENV.fetch('RAILS_TMP', Dir.tmpdir).to_s, "import_#{self.id}_#{self.importer_runs.last.id}_errored_entries.csv")
    rescue
      @errored_entries_csv_path ||= File.join(ENV.fetch('RAILS_TMP', Dir.tmpdir).to_s, "import_#{self.id}_0_errored_entries.csv")
    end
  end
end

app/models/bulkrax/oai_dc_entry.rb
# frozen_string_literal: true

module Bulkrax
  class OaiDcEntry < OaiEntry
  end
end

app/views/bulkrax/exporters/edit.html.erb
<% provide :page_header do %>
  <h1><span class="fa fa-edit" aria-hidden="true"></span> Edit Exporter</h1>
<% end %>

<div class="row">
  <div class="col-md-12">
    <div class="panel panel-default tabs">
      <%= simple_form_for @exporter do |form| %>
        <%= render 'form', exporter: @exporter, form: form %>
        <div class="panel-footer">
          <div class='pull-right'>
            <%= form.button :submit, value: 'Update Exporter', class: 'btn btn-primary' %>
            |
            <%= form.button :submit, value: 'Update and Re-Export All Items', class: 'btn btn-primary' %>
            |
            <% cancel_path = form.object.persisted? ? exporter_path(form.object) : exporters_path %>
            <%= link_to t('.cancel'), cancel_path, class: 'btn btn-default ' %>
          </div>
        </div>
      <% end %>
    </div>
  </div>
</div>

app/views/bulkrax/exporters/index.html.erb
<% provide :page_header do %>
  <h1><span class="fa fa-cloud-download" aria-hidden="true"></span> Exporters</h1>
  <div class="pull-right">
    <%= link_to new_exporter_path, class: 'btn btn-primary' do %>
      <span class="fa fa-edit" aria-hidden="true"></span> <%= t(:'helpers.action.exporter.new') %>
    <% end %>
  </div>
<% end %>

<div class="panel panel-default">
  <div class="panel-body">
    <% if @exporters.present? %>
      <div class="table-responsive">
        <table class="table table-striped datatable">
          <thead>
            <tr>
              <th scope="col">Name</th>
              <th scope="col">Status</th>
              <th scope="col">Date Exported</th>
              <th scope="col"></th>
              <th scope="col"></th>
              <th scope="col"></th>
              <th scope="col"></th>
            </tr>
          </thead>
          <tbody>
            <% @exporters.each do |exporter| %>
              <tr>
                <th scope="row"><%= link_to exporter.name, exporter_path(exporter) %></th>
                <td>
                  <% if exporter.last_error.present? %>
                    Failed
                  <% else %>
                    <%= exporter.exporter_runs.last&.exporter_status %>
                  <% end %>
                </td>
                <td><%= exporter.created_at %></td>
                <td>
                  <% if File.exist?(exporter.exporter_export_zip_path) %>
                    <%= link_to raw('<span class="glyphicon glyphicon-download"></span>'), exporter_download_path(exporter) %>
                  <% end%>
                </td>
                <td><%= link_to raw('<span class="glyphicon glyphicon-info-sign"></span>'), exporter_path(exporter) %></td>
                <td><%= link_to raw('<span class="glyphicon glyphicon-pencil"></span>'), edit_exporter_path(exporter) %></td>
                <td><%= link_to raw('<span class="glyphicon glyphicon-remove"></span>'), exporter, method: :delete, data: { confirm: 'Are you sure?' } %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      </div>
      <% else %>
        <p>No exporters have been created.</p>
      <% end %>
  </div>
</div>

<script>
  $(function() {
    $('#DataTables_Table_0').DataTable({
      destroy: true, /* Reinitialize DataTable with config below */
      'columnDefs': [
          { 'orderable': true, 'targets': [0, 1, 2] },
          { 'orderable': false, 'targets': [3, 4, 5, 6] }
      ],
      'language': {
        'info': 'Showing _START_ to _END_ of _TOTAL_ exporters',
        'infoEmpty': 'No exporters to show',
        'infoFiltered': '(filtered from _MAX_ total exporters)',
        'lengthMenu': 'Show _MENU_ exporters'
      }
    })
  })
</script>

app/views/bulkrax/exporters/new.html.erb
<% provide :page_header do %>
  <h1><span class="fa fa-edit" aria-hidden="true"></span> New Exporter</h1>
<% end %>

<div class="row">
  <div class="col-md-12">
    <div class="panel panel-default tabs">
      <%= simple_form_for @exporter do |form| %>
        <%= render 'form', exporter: @exporter, form: form %>
        <div class="panel-footer">
          <div class='pull-right'>
            <%= form.button :submit, value: 'Create and Export', class: 'btn btn-primary' %>
            |
            <%= form.button :submit, value: 'Create', class: 'btn btn-primary' %>
            |
            <% cancel_path = form.object.persisted? ? exporter_path(form.object) : exporters_path %>
            <%= link_to t('.cancel'), cancel_path, class: 'btn btn-default ' %>
          </div>
        </div>
      <% end %>
    </div>
  </div>
</div>

app/views/bulkrax/exporters/show.html.erb
<p id='notice'><%= notice %></p>

<div class='col-xs-12 main-header'>
  <h1><span class='fa fa-cloud-download' aria-hidden='true'></span> Exporter: <%= @exporter.name %></h1>
</div>

<div class='panel panel-default'>
  <div class='panel-body'>

    <p class='bulkrax-p-align'>
      <strong><%= t('bulkrax.exporter.labels.name') %>:</strong>
      <%= @exporter.name %>
    </p>

    <p class='bulkrax-p-align'>
      <strong><%= t('bulkrax.exporter.labels.user') %>:</strong>
      <%= @exporter.user %>
    </p>

    <p class='bulkrax-p-align'>
      <strong><%= t('bulkrax.exporter.labels.export_type') %>:</strong>
      <%= @exporter.export_type %>
    </p>

    <p class='bulkrax-p-align'>
      <strong><%= t('bulkrax.exporter.labels.export_from') %>:</strong>
      <%= @exporter.export_from %>
    </p>

    <p class='bulkrax-p-align'>
      <strong><%= t('bulkrax.exporter.labels.export_source') %>:</strong>
      <% case @exporter.export_from %>
      <% when 'collection' %>
        <% collection = Collection.find(@exporter.export_source) %>
        <%= link_to collection&.title&.first, hyrax.dashboard_collection_path(collection.id) %>
      <% when 'importer' %>
        <% importer = Bulkrax::Importer.find(@exporter.export_source) %>
        <%= link_to importer.name, bulkrax.importer_path(importer.id) %>
      <% when 'worktype' %>
        <%= @exporter.export_source %>
      <% end %>
    </p>

    <p class='bulkrax-p-align'>
      <strong><%= t('bulkrax.exporter.labels.parser_klass') %>:</strong>
      <%= @exporter.parser_klass %>
    </p>

    <p class='bulkrax-p-align'>
      <strong><%= t('bulkrax.exporter.labels.limit') %>:</strong>
      <%= @exporter.limit %>
    </p>

  <%= render partial: 'bulkrax/shared/bulkrax_field_mapping', locals: {item: @exporter} %>

    <%# Currently, no parser-specific fields exist on Exporter,
        thus there's no real reason to always show this field %>
    <% if @exporter.parser_fields.present? %>
      <p class='bulkrax-p-align'>
        <strong><%= t('bulkrax.exporter.labels.parser_fields') %>:</strong><br>
        <% @exporter.parser_fields.each do |k, v| %>
          <%= k %>: <%= v %><br>
        <% end %>
      </p>
    <% end %>

    <p class='bulkrax-p-align'><strong><%= t('bulkrax.exporter.labels.field_mapping') %>:</strong></p>

    <p class='bulkrax-p-align'>
      <strong><%= t('bulkrax.exporter.labels.total_work_entries') %>:</strong>
      <%= @exporter.exporter_runs.last&.total_work_entries %>
    </p>
    <br>
    <div class="bulkrax-nav-tab-table-left-align">
      <h2>Entries</h2>
      <table class='table table-striped'>
        <thead>
          <tr>
            <th>Identifier</th>
            <th>Collection</th>
            <th>Entry ID</th>
            <th>Status</th>
            <th>Errors</th>
            <th>Status Set At</th>
            <th>Actions</th>
          </tr>
        </thead>
        <tbody>
          <% @work_entries.each do |e| %>
            <tr>
              <td><%= link_to e.identifier, bulkrax.exporter_entry_path(@exporter.id, e.id) %></td>
              <% if e.parsed_metadata.present? && e.parsed_metadata.dig('collections').present? %>
                <td><%= e.parsed_metadata.dig('collections').map {|c| c['id'] }.join('; ') %></td>
              <% elsif e.raw_metadata.present? %>
                <td><%= Array.wrap(e.raw_metadata.dig('collection')).join(';') %></td>
              <% else %>
              <td></td>
              <% end %>
              <td><%= e.id %></td>
              <% if e.status == 'succeeded' %>
                <td><span class='glyphicon glyphicon-ok' style='color: green;'></span> <%= e.status %></td>
                <% else %>
                <td><span class='glyphicon glyphicon-remove' style='color: red;'></span> <%= e.status %></td>
              <% end %>
              <% if e.last_error.present? %>
                <td><%= link_to e.last_error.dig('error_class'), bulkrax.exporter_entry_path(@exporter.id, e.id) %></td>
              <% else %>
                <td></td>
              <% end %>
              <td><%= e.status_at %></td>
              <td><%= link_to raw("<span class='glyphicon glyphicon-info-sign'></span>"), bulkrax.exporter_entry_path(@exporter.id, e.id) %></td>
            </tr>
          <% end %>
        </tbody>
      </table>
      <%= page_entries_info(@work_entries) %><br>
      <%= paginate(@work_entries, param_name: :work_entries_page) %>
      <br>
      <%= link_to 'Edit', edit_exporter_path(@exporter) %>
      |
      <%= link_to 'Back', exporters_path %>
    </div>
  </div>
</div>